import { InputRule } from "../use-input/types";
import { InputValidityState } from "./types";
export declare function validateField(value: any, rules: Array<InputRule> | InputRule): Promise<string | boolean>;
/**
 * Form Validator
 */
export default function (props: {
    id?: string | null;
}, emit: ((event: "valid", _v: Record<string, any>) => void) & ((event: "invalid", _v: Record<string, any>) => void)): {
    state: Record<string, any>;
    rules: Record<string, InputRule | InputRule[]>;
    validity: Record<string, InputValidityState>;
    handleSubmit: (e: SubmitEvent) => Promise<void>;
    id: import("vue").ComputedRef<string>;
};
