export default function (): {
    rippleStyleObject: import("vue").ComputedRef<{
        "--ripple-pos-x": string;
        "--ripple-pos-y": string;
        "--ripple-width": string;
        "--ripple-height": string;
        "--ripple-opacity": string;
        "--ripple-scale": string;
        "--transition-property": string;
    }>;
    events: {
        onPointerdown: (event: MouseEvent | TouchEvent) => void;
        onPointerup: (event: MouseEvent | TouchEvent) => void;
        onPointerleave: (event: MouseEvent | TouchEvent) => void;
    };
};
