import { CustomInspectorNode, CustomInspectorState, DevtoolsPluginApi, ExtractSettingsTypes, PluginSettingsItem } from "@vue/devtools-api";
declare type Api = DevtoolsPluginApi<ExtractSettingsTypes<Record<string, PluginSettingsItem>>>;
/**
 * Default nodes for the inspector
 */
export declare const nodes: Array<CustomInspectorNode>;
export declare const state: Record<string, CustomInspectorState>;
export declare function updateFormState(globalState: Record<string, any>): void;
export declare function registerToNode(nodeId: string, data: CustomInspectorNode): void;
export declare function removeFromNodes(nodeId: string, id: string): void;
export default function (devtoolsApi: Api): void;
export {};
