import { InputValidityState } from '../composables/use-form/types';
import { InputRule } from '../composables/use-input/types';
import { InjectionKey } from "vue";
export declare const REGISTER_INPUT: InjectionKey<(name: string, defaultValue: any, rules: Array<InputRule> | InputRule) => void>;
export declare const DEREGISTER_INPUT: InjectionKey<(name: string) => void>;
export declare const UPDATE_INPUT_VALUE: InjectionKey<(name: string, value: any) => void>;
export declare const VALIDATION_STATE: InjectionKey<Record<string, InputValidityState>>;
